///////////////////////////////////////////////////////////////////////////////	
//    Ashtech receiver tools
//    Copyright (C) 1999  Magellan Coropration/Ashtech Precision Products 
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
///////////////////////////////////////////////////////////////////////////////


#include <string.h>

#include "rdrtime.hpp"

extern RdRtime *dwl;


void Init_f_createFile()
{ dwl->fcf.f_createBfile=0;
  dwl->fcf.f_createheaderCBfile=2;
  dwl->fwf.f_writeheaderCBfile=0;  // rewrite header C or B -file
  dwl->fcf.f_createCfile=0;
  dwl->fcf.f_createSfile=0;       
  dwl->fcf.f_createEfile=0;
  dwl->fcf.f_createDfile=0;
  dwl->fcf.f_createNfile=0;
  dwl->fcf.f_createAfile=0;
  dwl->fcf.f_createPfile=0;	
	dwl->fcf.f_createVispaRawfile=0;
}

void Init_f_writeFile()
{ dwl->fwf.f_writeBfile=0;
  dwl->fwf.f_writeSfile=0;	  
  dwl->fwf.f_writeEfile=0;
  dwl->fwf.f_writeDfile=0;
  dwl->fwf.f_writeNfile=0;
  dwl->fwf.f_writeAfile=0;
  dwl->fwf.f_writePfile=0;
	dwl->fwf.f_writeVispaRawfile=0;
}

void Write_file_trans(bool AlmanacWrite) 
{ 
	file_trans pft;
  pft.DataSize=-1;
	
	if (AlmanacWrite==true)
	{ pft.DataSize=(short)dwl->len_almanac;
		pft.fCreate=0;
		if (dwl->rec_type_code==0)
		{	memcpy(&dwl->bf.vibf[0],&dwl->alm,pft.DataSize);
			strcpy(pft.vname_file,(char *)dwl->file_rec.file_name);
		}
		else
		{ memcpy(&dwl->bf.vibf[0],&dwl->malm[dwl->malmanac_strctindex].alm,pft.DataSize);
			memcpy(pft.vname_file, (char *)dwl->malm[dwl->malmanac_strctindex].almanac_name, 10);
		}
		pft.pData=dwl->bf.vibf;
	}
	else
	{	if ((dwl->fwf.f_writeBfile>0)||(dwl->fwf.f_writeheaderCBfile>0))
		{	if (dwl->fwf.f_writeBfile>0)
			{ if (dwl->vfile_name.nameB_file[0]=='B')
				{ pft.fCreate=dwl->fcf.f_createBfile;
					dwl->fcf.f_createBfile=1;
				}
				else  
				{ pft.fCreate=dwl->fcf.f_createCfile;
					dwl->fcf.f_createCfile=1;
				}
			}
			if (dwl->fwf.f_writeheaderCBfile>0) pft.fCreate=dwl->fcf.f_createheaderCBfile;
			pft.DataSize=dwl->len_epoch;
			pft.pData=dwl->one_epochbuf;
			memcpy(pft.vname_file, (char *)dwl->vfile_name.nameB_file, 13);           
		}
		else if (dwl->fwf.f_writeEfile>0)
		{ pft.fCreate=dwl->fcf.f_createEfile;
			dwl->fcf.f_createEfile=1;
			pft.DataSize=dwl->len_satbuf;     
  		pft.pData=dwl->one_satbuf;
  		memcpy(pft.vname_file, (char *)dwl->vfile_name.nameE_file, 13);           
		}
		else if (dwl->fwf.f_writeSfile>0)	  
		{ pft.fCreate=dwl->fcf.f_createSfile;
			dwl->fcf.f_createSfile=1;
			if (dwl->rec_type_code==MICRO_Z)
    		if ((dwl->rawfile.V_file.name[0]=='U')||(dwl->rawfile.V_file.name[0]=='u')) 
    			dwl->fcf.f_createSfile=0;
	    pft.DataSize=dwl->len_strS;     
			pft.pData=dwl->str_Sfile;                         
  		memcpy(pft.vname_file, (char *)dwl->vfile_name.nameS_file, 13);           
		}
		else if (dwl->fwf.f_writeDfile>0)
		{ pft.fCreate=dwl->fcf.f_createDfile;
	    dwl->fcf.f_createDfile=1;
			pft.DataSize=dwl->len_strD;     
  		pft.pData=dwl->str_Dfile;
  		memcpy(pft.vname_file, (char *)dwl->vfile_name.nameD_file, 13);           
		}
		else if (dwl->fwf.f_writeNfile>0)
		{ pft.fCreate=dwl->fcf.f_createNfile;
			dwl->fcf.f_createNfile=1;
			pft.DataSize=dwl->len_rnav;     
  		pft.pData=&dwl->rnav;
  		memcpy(pft.vname_file, (char *)dwl->vfile_name.nameN_file, 13);           
		}
		else if (dwl->fwf.f_writeAfile>0)
		{ pft.fCreate=dwl->fcf.f_createAfile;
			dwl->fcf.f_createAfile=1;      
			pft.DataSize=dwl->len_strRA;
			pft.pData=dwl->str_RAfile; 
			memcpy(pft.vname_file, (char *)dwl->vfile_name.nameA_file, 13);           
		}
		else if (dwl->fwf.f_writePfile>0)	
		{ pft.fCreate=dwl->fcf.f_createPfile;
	    dwl->fcf.f_createPfile=1;      
			pft.DataSize=dwl->len_strP;
			pft.pData=dwl->str_photofile;
			if (dwl->rec_type_code==MICRO_Z) dwl->vfile_name.nameP_file[0]='M';
			memcpy(pft.vname_file, (char *)dwl->vfile_name.nameP_file, 13);             
		}
	}
	if (pft.DataSize>0)
	{ FILE  *pDataFile;
		char  _pathDataFile[200];
		char  ren_pathDataFile[200];
		short length_path;

		if (dwl->pathDataFile[0]!='\0') 
		{	strcpy(_pathDataFile,dwl->pathDataFile);
			length_path=strlen(_pathDataFile);
#ifdef __GNUC__				
				if (_pathDataFile[length_path-1]!='/') strcpy(&_pathDataFile[length_path],"/\0");
#else
				if (_pathDataFile[length_path-1]!='\\')strcpy(&_pathDataFile[length_path],"\\\0");			
#endif			
			strcat(_pathDataFile, pft.vname_file); 
		}
		else
			strcpy(_pathDataFile, pft.vname_file); 
	  switch (pft.fCreate)
		{ case 0:	// 0 - open file first time
				pDataFile=fopen(_pathDataFile,"wb");
			  break;
		  case 1:	// 1 - append in file
		 	  pDataFile=fopen(_pathDataFile,"a+b");
				break;
		  case 2:	// 2 - rewrite began file
			  pDataFile=fopen(_pathDataFile,"r+b");
				if (pDataFile!=NULL) fseek(pDataFile,0L,SEEK_SET);
				break;
		}
		if (pDataFile==NULL) return;
		fwrite(pft.pData,pft.DataSize,1,pDataFile);
	  fclose(pDataFile); 
		pDataFile=NULL;
		if ((dwl->fwf.f_writeBfile==1)&&(dwl->fwf.f_writeheaderCBfile==1)&&(pft.DataSize==sizeof(dwl->rh)))
		{	if (dwl->ChangeSessionName()==TRANS_OK)
			{	length_path=strlen(_pathDataFile);
				strcpy(ren_pathDataFile,_pathDataFile);
				strcpy(&ren_pathDataFile[length_path-11],(char *)dwl->file_rec.file_name);
				rename(_pathDataFile,ren_pathDataFile);
				_pathDataFile[length_path-12]='E';
				ren_pathDataFile[length_path-12]='E';
				rename(_pathDataFile,ren_pathDataFile);
			}
		}	
	}
}

int RewriteHeaderCfile()
{
  dwl->len_epoch=0;
  dwl->fwf.f_writeheaderCBfile=1;
  dwl->write_headerCfile(); // last fa.ranger_diff_mode! 
  return(COLLECTING_DATA);
}

void CloseDownload()
{ 
  if (dwl!=NULL)
	{ delete(dwl);
		dwl=NULL;
	}
}