///////////////////////////////////////////////////////////////////////////////	
//    Ashtech receiver tools
//    Copyright (C) 1999  Magellan Coropration/Ashtech Precision Products 
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
///////////////////////////////////////////////////////////////////////////////


#include <string.h>

#ifndef __TRANS_HPP
#include "trans.hpp"
#endif

short Trans::FormSfile()
{{ // formats ...\strings\dnld.c
  char mh[3],d[3],option[10];

  fwf.f_writeSfile=1;
  strncpy(mh,file_header.project.month,2); mh[2]='\0';
  strncpy(d,file_header.project.day,2); d[2]='\0';
  if (rec_type_code==MICRO_Z) 
    strcpy(option,MZreceiver_option);
  else  
  { if (strncmp((char *)typ_rec.receiver_option,"N/A\0",3))
    { option[0]=typ_rec.co_processor; option[1]='\0';
      strcat(option,(char *)typ_rec.receiver_option);
    }
    else
      strcpy(option,(char *)typ_rec.receiver_option);
  }
  len_strS =sprintf(str_Sfile,"************ SITE INFORMATION *********************************\r\n");
  len_strS+=sprintf(&str_Sfile[len_strS],"NAME  WORDS   WEEK   TIME    ");
  len_strS+=sprintf(&str_Sfile[len_strS],"SES RCR ANT MMDD OPR CODE             TYPE\r\n");
  len_strS+=sprintf(&str_Sfile[len_strS],"%4.4s %7lu ",file_header.segname,file_header.wordcount*2);
  len_strS+=sprintf(&str_Sfile[len_strS],"%4d %8lu ",file_header.segwn,file_header.segtime);
  len_strS+=sprintf(&str_Sfile[len_strS],"   %c  %3.3s %3.3s %2.2s%2.2s %3.3s %13.13s  %8.8s\r\n\r\n",
							      file_header.project.ses_name, file_rec.rcv_num,
										file_rec.ant_num, mh, d, file_rec.operators,
										file_rec.comment, file_rec.file_type);
  len_strS+=sprintf(&str_Sfile[len_strS],"          HI   T-DRY T-WET  HUMIDITY  PRESSURE \r\n");
  len_strS+=sprintf(&str_Sfile[len_strS],"BEFORE %7.4f  %3d   %3d    %3d      %5.1f \r\n",
										file_rec.ahibef,file_rec.temp_drybef,file_rec.temp_wetbef,
										file_rec.humiditybef,file_rec.presbef);
  len_strS+=sprintf(&str_Sfile[len_strS],"AFTER  %7.4f  %3d   %3d    %3d      %5.1f \r\n\r\n",
										file_rec.ahiaft,file_rec.temp_dryaft,file_rec.temp_wetaft,
										file_rec.humidityaft,file_rec.presaft);
  len_strS+=sprintf(&str_Sfile[len_strS],"RECEIVER Type: %8.8s",rh.rcvr_type);
  len_strS+=sprintf(&str_Sfile[len_strS]," Nav: %s  Channel: %s  Options: %s\r\n", 
                    rh.nav_ver, rh.chan_ver,option);
  len_strS+=sprintf(&str_Sfile[len_strS],
    "***************************************************************\r\n");

  if (rec_type_code == DF3)
    len_strS+=sprintf(&str_Sfile[len_strS],
											"SECOFWEEK   HEADING    PITCH     ROLL      MRMS      BRMS     RESET\r\n");

  return(TRANS_OK);
}}

