///////////////////////////////////////////////////////////////////////////////	
//    Ashtech receiver tools
//    Copyright (C) 1999  Magellan Coropration/Ashtech Precision Products 
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
///////////////////////////////////////////////////////////////////////////////


#include <string.h>

#ifndef __TRANS_HPP
#include "trans.hpp"
#endif

Trans::Trans()
{{
  bf.ibf[0]=bf.tbf[0]='\0';
  
  almanac_number=0;
  malmanac_strctindex=-1;
	rh.wn_start=-1;
	ser_num_rec[0]='\0';
	rid_options[0]='\0';
	pathDataFile[0]='\0';

	fImage=NULL;
	f_swap_dataZ18=0;
	file_rec.file_name[0]='\0';
	rawfile.V_file.name[0]='\0';
	f_ring_buffer=0;
	f_renfile_cline=0;
}};


unsigned short Trans::Checksum16(const unsigned char *ibf)
{{
  short 				 i,vn;
  unsigned short checksum=0,c=0;
  unsigned long  sum;

  vn=com.cnbyte-2;
  for (i=0;i<vn;i=i+2)
  { if (i+1==vn)
      sum=checksum+ (unsigned short) ibf[i];
    else
    { memcpy(&c,&ibf[i],2);
      sum=checksum+c;
    }
    if (sum>65535) sum=sum-65536;
    checksum=(unsigned short)sum;
  }
  checksum=checksum- (unsigned short) ibf[0];
  return(checksum);
}}


short Trans::IndentBuf_CheckingChecksum16()
{{
 	unsigned short check16,checksum;
 	
 	memmove(&bf.ibf[1],bf.ibf,com.cnbyte);
 	com.cnbyte+=1; bf.ibf[0]=bf.tbf[0];
	check16 = Checksum16( bf.ibf );
  
  memcpy(&checksum,&bf.ibf[com.cnbyte-2],sizeof(checksum));
  swap_nbytes((char *)&checksum,sizeof(checksum));
  if (checksum!=check16) return(ERROR_CHECKSUM);

	return(TRANS_OK);
}}

unsigned short Trans::ChecksumXOR(const unsigned char *ibf, unsigned short unused_bytes)
{{
  unsigned short i,vn,checksum=0;

  vn=com.cnbyte-unused_bytes;
  for (i=1;i<vn;i++) checksum=checksum^ibf[i];
  return(checksum);
}}

void Trans::SendRdfromRec()
{{
	com.cnbyte=rdd.cword*2;
	fread(&bf.ibf,com.cnbyte,1,fImage);
}}

void Trans::ControlRXCount()
{{
  // '\x04' <--
  com.cnbyte=rdd.cword*2;
  // &bf.tbf[1] 6 bytes - > com.cnbyte
}}

