///////////////////////////////////////////////////////////////////////////////	
//    Ashtech receiver tools
//    Copyright (C) 1999  Magellan Coropration/Ashtech Precision Products 
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
///////////////////////////////////////////////////////////////////////////////


#include <stdlib.h>
#include <string.h>

#ifndef __TRANS_HPP
#include "trans.hpp"
#endif

#ifndef __HOSEUTIL_HPP
#include "hoseutil.hpp"
#endif 

short Trans::ReceiverInfofromDumpMemory(const char* _pathImagefile)
{{
  short	i,j,change_i;

	strcpy((char *)pathImagefile, _pathImagefile);
	fImage=fopen((char *)pathImagefile,"rb");
  if (fImage==NULL) return(NO_FILE);

	if (f_ring_buffer) com.cnbyte=150; else com.cnbyte=170;
	fread(bf.ibf,com.cnbyte,1,fImage);
	memcpy(&image_head,bf.ibf,sizeof(image_head));
	if (strstr((char *)image_head.rcvr_type,"Z-12\0")!=NULL)
		memcpy(image_head.rcvr_type,"Z-XII P3",8); // for variant of Z12 name !!!
	for(i=1;i<KNOWN_RECEIVERS_NUMBER;i++)
	  if (strstr((char *)image_head.rcvr_type,ReceiverName(i))!=NULL) break;
	rec_type_code=i%KNOWN_RECEIVERS_NUMBER;    
	if (rec_type_code==UNKNOWN) return(NO_FILE);

	fa.num_photo=0; // for indefication addr in askPhotodata() !!!
  typ_rec.channel_option=image_head.version[0]-'0';
  typ_rec.codeless_option=0;
  if ((rec_type_code==SUPER_CA)||(rec_type_code==LCS_XII)) typ_rec.channel_option=4;
  change_i=(short)strlen(image_head.version);
	for (i=0;i<change_i;i++)
		if (image_head.version[i]==',') break;
	change_i=i+1;
	for (j=0,i=change_i;j<4;j++,i++)
	{	if (image_head.version[i]==',') break;
		typ_rec.nav_version[j]=image_head.version[i];
	}
	typ_rec.nav_version[j]='\0'; i+=1; // at co_processor 
  typ_rec.co_processor=image_head.version[i]; i+=1;
  if (rec_type_code>Z_XII) typ_rec.co_processor='N';
  for (j=0;j<3;j++,i++)
	{	if (image_head.version[i]==',') break;
		typ_rec.receiver_option[j]=image_head.version[i];
	}
  typ_rec.receiver_option[j]='\0'; i+=1;
	// rid_options -> for write in D-file only !!!
	if (strcmp((char *)typ_rec.receiver_option,"N/A\0"))
  { rid_options[0]=typ_rec.co_processor; rid_options[1]='\0';
    strcat(rid_options,(char *)typ_rec.receiver_option);
  }
  else
    strcpy(rid_options,(char *)typ_rec.receiver_option);
	strcpy((char *)typ_rec.channel_version,&image_head.version[i]);
	
  if ((typ_rec.nav_version[0]=='5')&&(typ_rec.nav_version[1]<'E'))
    fa.rcvr_version=A_5;
  else
  { if ((typ_rec.nav_version[0]=='6')&&(typ_rec.nav_version[1]<'F'))
      fa.rcvr_version=A_6;
    else
    if ((typ_rec.nav_version[0]=='5')&&(typ_rec.nav_version[1]<'F'))
			fa.rcvr_version=E_5;	
		else
			fa.rcvr_version=F_6;
  }
  
  ant_factor=10000.0;
  adj_ant_factor();

	typ_rec.data_address=image_head.data_start;
  typ_rec.data_length=image_head.data_end-typ_rec.data_address;   
  typ_rec.photo_address=image_head.photo_start; 
  typ_rec.photo_length=image_head.photo_end-typ_rec.photo_address;
  typ_rec.max_size=image_head.total_memory;
	
	BfileRawhead(); // from information of receiver
	return(TRANS_OK);
}}

void Trans::CloseDumpMemoryFile()
{{
	if (fImage!=NULL)
	{ fclose(fImage);
		fImage=NULL;
	}
}}

