///////////////////////////////////////////////////////////////////////////////	
//    Ashtech receiver tools
//    Copyright (C) 1999  Magellan Coropration/Ashtech Precision Products 
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
///////////////////////////////////////////////////////////////////////////////


#include <string.h>

#include "rdrtime.hpp"
#include "download.hpp"

RdRtime *dwl=NULL;

void main(int argc, char *argv[])
{
	short  length_path, error=TRANS_OK;
	short  first_letter=0;
	int    init_argc;
	double curr_percent;
	char 	 rawdatafile_name[200];
	char   sf_ring[3];

	if (argc<2) return;
	
	dwl = new RdRtime();
  if (dwl==NULL) return;

	memcpy(sf_ring,argv[1],2); sf_ring[2]='\0';
	if ((sf_ring[0]=='-')&&((sf_ring[1]=='F')||(sf_ring[1]=='f')))
	{	init_argc=4;
		dwl->Set_ring_buffer();
	}
	else
		init_argc=3;
	if ((argc==init_argc)||(argc==(init_argc+2))) strcpy(dwl->pathDataFile,argv[init_argc-1]);
	if (argc>init_argc) strcpy((char *)dwl->file_rec.file_name,argv[argc-1]);
	// ***********************************  Initialization ******************************************
	strcpy(rawdatafile_name,argv[init_argc-2]);
	length_path=strlen(rawdatafile_name);
	for (first_letter=length_path; first_letter>=0; first_letter--)
	{	
#ifdef __GNUC__				
				if (rawdatafile_name[first_letter]=='/') 
#else
				if (rawdatafile_name[first_letter]=='\\') 
#endif			
				{	first_letter++;
					break;
				}
	}
	if (first_letter<0) first_letter=0;
	dwl->Set_first_letter_name(first_letter);
	if ((rawdatafile_name[first_letter]=='R')||(rawdatafile_name[first_letter]=='r'))
	{	error=dwl->ReceiverInfofromDumpMemory(rawdatafile_name);
		if (error!=TRANS_OK) { dwl->CloseDumpMemoryFile(); CloseDownload(); return; }
		Init_f_createFile();
		Init_f_writeFile();
		dwl->Set_type_analyse(ANSHEAD);
		error=dwl->AnalysReadfRec(); //analysis head.file and SendRdfromRec()!!! 
		if (error==COLLECTING_DATA) error=TRANS_OK;
		if (error==TRANS_OK)
		{ dwl->FormSfile();
			Write_file_trans();
		}
		else
		{ dwl->CloseDumpMemoryFile(); 
			CloseDownload(); 
			return; 
		}	
	}
	else
	if ((rawdatafile_name[first_letter]=='U')||(rawdatafile_name[first_letter]=='u'))
	{	dwl->rid_options[0]='\0';
		error=dwl->ans_FileDirCountMZ(rawdatafile_name);
		if (error!=TRANS_OK) { CloseDownload(); return; }
		// Emulation $PASHQ,RID for MicroZ
		strcpy((char *)dwl->bf.ibf,"$PASHR,RID,UZ,30,U122,BUEXM-T3J,0A12*5A\r\n\0");
		dwl->bf.tbf[0]=dwl->bf.ibf[0];
		dwl->ansReceiverInfo(41); 
		dwl->Init_almanac_strct();
		// ******************************** for S-file Initialization ************************************
		dwl->InitHeadYFile();
		// ************************************* Download files ******************************************
		dwl->InitDownloadData();
		dwl->rawsession_bytes=0L;
		dwl->setCountPercent(0.0);
		Init_f_createFile();
		dwl->InitforReadVWfile();
	}
	else // converting Logfile
	{	error=dwl->OpenLogFile(rawdatafile_name);
		if (error!=TRANS_OK) { CloseDownload(); return; }
		strcpy((char *)dwl->bf.ibf,"$PASHR,RID,__,30,____,_________,____*5A\r\n\0");
		dwl->bf.tbf[0]=dwl->bf.ibf[0];
		dwl->ansReceiverInfo(41); 
		dwl->Init_analys_LogData();
		Init_f_createFile();
		dwl->Init_almanac_strct();
	}
	dwl->InitSNV_parameters();

	for (;;) // U-file or R-file converting
	{	if ((dwl->rec_type_code<G_XII)&&(dwl->rec_type_code>0))
		{	Init_f_writeFile();
			if (dwl->fwf.f_writeheaderCBfile==0)
				error=dwl->AnalysReadfRec(); // read data and SendRdfromRec()!!!   
			else
			{ RewriteHeaderCfile();
				error=TRANS_OK;           
			}  
			Write_file_trans();
			if (dwl->fwf.f_writeheaderCBfile==0)
			{ if ((error==TRANS_OK)&&(dwl->Get_curr_file_type()==RANGER_MODE2))
				{ dwl->fwf.f_writeheaderCBfile=1; // only herein !!!
					error=COLLECTING_DATA;         
				}
			}    
			if ((error>=ERROR_MODEHOSE)||(error==TRANS_OK))
			{	dwl->CloseDumpMemoryFile();
				break;
			}
		}
		else
		if (dwl->rec_type_code==0) // converting Logfile
		{	error=dwl->ReadBuf();	
			if (error==TRANS_OK)
			{	Init_f_writeFile();
				dwl->RewriteHeaderBfile(); // rh.wn_start !!!
				Write_file_trans();
				Init_f_writeFile();
				error=dwl->AlmanacNameFile();
				if (error==TRANS_OK) Write_file_trans(true);
				dwl->CloseDumpMemoryFile();
				break;
			}
			for (;;)	
			{	Init_f_writeFile();
				error=dwl->AnalysRdRtime();
				Write_file_trans();
				if (error==FILLBUF) break;
			}
		}
		else
		{	if ((dwl->rawfile.V_file.name[0]=='U')||(dwl->rawfile.V_file.name[0]=='u'))
			{ if (dwl->f_fillbuf==0)
					error=dwl->ReadBlocksUfile(rawdatafile_name);
				else
				{ Init_f_writeFile();
					if (dwl->f_fillbuf==3)
					{ error=dwl->AlmanacNameFile();
						if (error==NO_FILE) error=ERROR_RCI;
						if (error==TRANS_OK) Write_file_trans(true);
					}  
					else
					{ if (dwl->f_fillbuf==2)
						{ error=RewriteHeaderCfile();
							dwl->f_fillbuf=3;	
						}
						if (dwl->f_fillbuf==1)
						{ error=dwl->AnalysDataBlocks();
							if (dwl->f_fillbuf==0)
							error=dwl->EndReadFile(error);
						}
						Write_file_trans();
					}
				}  
			}
			else 
				error=NO_FILE;	
			
			if ((error>COLLECTING_DATA)&&(error<ERROR_RCI)&&(dwl->GetCurrbytesRawfiles()>8)&&(error!=ERROR_DATATYPE)) 
				error=ERROR_CHECKSUM; // no break cycled process !!!
			if ((error==COLLECTING_DATA)||(error==TRANS_OK)||(error==ERROR_CHECKSUM))	
			{ curr_percent=dwl->rawsession_bytes+dwl->GetCurrbytesRawfiles();
				curr_percent=100.0*curr_percent/dwl->rawfile.numbytes_session+0.5;
				if (curr_percent > 100.0) curr_percent=100.0;
				dwl->setCountPercent(curr_percent);
			}
			if ((error!=COLLECTING_DATA)&&(error!=ERROR_CHECKSUM))		
			{ dwl->CloseReadVWfile();
				break; 	
			}
		}
	}
	CloseDownload();
  return;
}


