///////////////////////////////////////////////////////////////////////////////
//    Ashtech receiver tools
//    Copyright (C) 1999  Magellan Coropration/Ashtech Precision Products
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
///////////////////////////////////////////////////////////////////////////////


#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <math.h>
#include <limits.h>
#include <time.h>

#ifndef __RDRTIME_HPP
#include "rdrtime.hpp"
#endif


void RdRtime::Init_varrawfile_name()
{{
  rawfile.V_file.name[0]='\0';
  rawfile.W_file.name[0]='\0';
  rawfile.Y_file.name[0]='\0';
  rawfile.E_file.name[0]='\0';
  rawfile.M_file.name[0]='\0';
  rawfile.D_file.name[0]='\0';
  rawfile.numbytes_session=0L;
}}

void RdRtime::Set_varrawfile_name(short index_file)
{{ // this function call without "default" in switch-operator always !!!
  switch (filedir_name[f_letter_name])
  { case 'u':
		case 'U':
    	strcpy((char *)rawfile.V_file.name, &filedir_name[f_letter_name]);
    	rawfile.V_file.bytes=curr_bytes;
    	break;
  }
  rawfile.numbytes_session+=curr_bytes;
  sprintf((char *)all_file_rec.bytes,"%7ld\0",rawfile.numbytes_session);
}}


short RdRtime::ControlReceiverFileName()
{{
  short error;
  short len_name;

  len_name=strlen(filedir_name);
  if (len_name<9) return(NO_FILE);
  error=atoi(&filedir_name[len_name-3]);
  if ((error<=0)||(error>366)) return(NO_FILE);
	if ((isdigit(filedir_name[len_name-3])==0)||
			(isdigit(filedir_name[len_name-2])==0)||
			(isdigit(filedir_name[len_name-1])==0)
		 )
	return(NO_FILE);
  //if ((isdigit(filedir_name[len_name-5])==0)||(isdigit(filedir_name[len_name-6])==0)) return(NO_FILE);

  return(TRANS_OK);
}}

short RdRtime::ControlSession()
{{
  short error;

  error=ControlReceiverFileName();
  if (error!=TRANS_OK) return(error);

  switch (filedir_name[f_letter_name])
  { case 'U':
		case 'u':
      error=TRANS_OK;
      break;
    default:
      error=NO_FILE;
  }
  return(error);
}}

void RdRtime::FillInitCurrSession()
{{
  Init_varrawfile_name();
	if (file_rec.file_name[0]=='\0')
	{	strcpy((char *)all_file_rec.rawfile_name, &filedir_name[f_letter_name+1]);
    strcpy((char *)all_file_rec.file_name, &filedir_name[f_letter_name+1]);
	}
	else
	{ strcpy((char *)all_file_rec.rawfile_name, (char *)file_rec.file_name);
    strcpy((char *)all_file_rec.file_name, (char *)file_rec.file_name);
	}
	sprintf((char *)all_file_rec.file_type,(char *)file_types[0]); // GEODETIC
}}

void RdRtime::FillSession()
{{
  FillInitCurrSession();
  Set_varrawfile_name(0); // + size session !!!
}}

short RdRtime::ans_FileDirCountMZ(const char *ansFirstNext)
{{
  long length_files;

	strcpy(filedir_name,ansFirstNext);
  if (ControlSession()!=TRANS_OK) return(NO_FILE);
  fVWfile=fopen(filedir_name,"rb");
	if (fVWfile==NULL) return(NO_FILE);
	fseek(fVWfile,0L,SEEK_END);
	length_files=ftell(fVWfile);
	if (length_files<0L)
		return(NO_FILE);
	else
		curr_bytes=(unsigned long) length_files;
	fclose(fVWfile); fVWfile=NULL;
	FillSession();
	return(TRANS_OK);
}}

short RdRtime::AvailabilityDownloadFile(const unsigned char *varrawfile_name)
{{
  if (varrawfile_name[0])
  	return(TRANS_OK);
  else
    return(NO_FILE);
}}

void RdRtime::ReadfromYstrct(unsigned short &_i_head)
{{
  swap_nbytes((char *)&file_header.segwn ,sizeof(file_header.segwn));
  if (file_header.segwn < 815) file_header.segwn+=1024; // new epoch 22 august 1999 !!!
  swap_nbytes((char *)&file_header.segtime ,sizeof(file_header.segtime));

  memcpy(&file_rec.ahibef,&bf.ibf[_i_head],4); _i_head+=4;
  swap_nbytes((char *)&file_rec.ahibef ,sizeof(file_rec.ahibef));
  memcpy(&file_rec.ahiaft,&bf.ibf[_i_head],4); _i_head+=4;
  swap_nbytes((char *)&file_rec.ahiaft ,sizeof(file_rec.ahiaft));
  file_header.anthibef = (unsigned short) file_rec.ahibef;
  file_header.anthiaft = (unsigned short) file_rec.ahiaft;

  memcpy(&file_header.drybef,&bf.ibf[_i_head],10); _i_head+=10;
  swap_nbytes((char *)&file_header.pressurebef,
		sizeof(file_header.pressurebef));
  swap_nbytes((char *)&file_header.pressureaft,
		sizeof(file_header.pressureaft));

  strcpy(rn.sitename,file_header.segname);

  memcpy(rh.nav_ver, &bf.ibf[_i_head], 4);        rh.nav_ver[4]='\0';        _i_head+=4;
  memcpy(rh.chan_ver,  &bf.ibf[_i_head], 4);      rh.chan_ver[4]='\0';       _i_head+=4;
  memcpy(MZreceiver_option, &bf.ibf[_i_head], 9); MZreceiver_option[9]='\0'; _i_head+=9;
  memcpy(rh.rcvr_type, &bf.ibf[_i_head], 5);      rh.rcvr_type[5]='\0';      _i_head+=5;
}}


short RdRtime::GetYbody()
{{
  unsigned short i_head;
	short          error = TRANS_OK;

  error=IndentBuf_CheckingChecksum16();
  if (error!=TRANS_OK) return(error);

	file_rec.session=rawfile.V_file.name[5];
  i_head=1;
  memcpy(&file_header.wordcount,&bf.ibf[i_head],60); i_head+=60;
  swap_nbytes((char *)&file_header.wordcount ,sizeof(file_header.wordcount));

	ReadfromYstrct(i_head);
  strcpy((char *)file_rec.rawfile_name, (char *)all_file_rec.rawfile_name);
  strcpy((char *)file_rec.file_name, (char *)all_file_rec.file_name);
  strcpy((char *)file_rec.bytes, (char *)all_file_rec.bytes);
  FormInfFileRec();

	return(TRANS_OK);
}}

void RdRtime::InitHeadYFile()
{{
  if ((strstr((char *)all_file_rec.file_type,"GEODETIC\0")==NULL)&&
			(strstr((char *)all_file_rec.file_type,"RANGER 2\0")==NULL)&&
		  (strstr((char *)all_file_rec.file_type,"RANGER 4\0")==NULL)
		 )
		return;
	strcpy((char *)file_rec.file_name, (char *)all_file_rec.file_name);
  strncpy((char *)all_file_rec.site, (char *)file_rec.file_name,4);
	all_file_rec.site[4]='\0';
	all_file_rec.session=file_rec.file_name[4];

	strcpy((char *)all_file_rec.rcv_num,"___\0");
  strcpy((char *)all_file_rec.ant_num,"___\0");
  strcpy((char *)all_file_rec.operators,"___\0");
  strcpy((char *)all_file_rec.comment,"_____________\0");
  all_file_rec.ahibef=  0.0;
  all_file_rec.ahiaft=  0.0;
  all_file_rec.presbef= 0.0;
  all_file_rec.presaft= 0.0;
  all_file_rec.temp_drybef= 0;
  all_file_rec.temp_dryaft= 0;
  all_file_rec.temp_wetbef= 0;
  all_file_rec.temp_wetaft= 0;
  all_file_rec.humiditybef= 0;
  all_file_rec.humidityaft= 0;

  fa.curr_file_type = -1;
	if ((rawfile.V_file.name[0]=='U')||(rawfile.V_file.name[0]=='u'))
		fa.curr_file_type = 0;
	if (rawfile.W_file.name[0]=='W') fa.curr_file_type = 2;
	if ((rawfile.V_file.name[0]=='V')&&(rawfile.W_file.name[0]=='W'))
		fa.curr_file_type = 4;
	if ((fa.curr_file_type==0)||(fa.curr_file_type==2)||(fa.curr_file_type==4))
	{ strcpy((char *)all_file_rec.file_type,(char *)file_types[fa.curr_file_type]);
		FormVarNamesFiles();
	}
  // Init. data !!!
  InitDownloadData();
}}

void RdRtime::InitforReadVWfile()
{{
  fVWfile=NULL;
  f_one_epoch=0; // flag write rh in one_epochbuf.
	pathVWfile[0]='\0';
	rawfile_length=rawfile.V_file.bytes;
  if ((rawfile.V_file.name[0]=='U')||(rawfile.V_file.name[0]=='u'))
  { vmem.sum_blocks=(unsigned long) ceil(rawfile_length/512.0);
  	vmem.num_blocks=0L;
  	com.cnbyte=512;
  	rtc.beg_buf=0;
  	f_fillbuf=0;
  	rtc.index_static_buf=0;
  	Init_almanac_strct();
  	len_strS=0;
		time_tag=4;
  }
}}

void RdRtime::CloseReadVWfile()
{{
  if (fVWfile!=NULL)
  { fclose(fVWfile);
    fVWfile=NULL;
  }
}}

short RdRtime::GetHeaderBfile()
{{
	short error=TRANS_OK;

  error=IndentBuf_CheckingChecksum16();
	if (error!=TRANS_OK) return(error);

	memcpy(&rh,&bf.ibf[1],sizeof(rh));
  return(error);
}}

short RdRtime::CurrAlmanacName()
{{
  long   day_year,h,m,year=0L;
  double sec;

  if (rtt.alm_wn>0)
    gps_to_ydhms(rtt.alm_wn,rtt.alm_tow,&year,&day_year,&h,&m,&sec);
  if (year>0)
  { if (year>1900) year -=1900;
    if (year>=100) year -=100;
    sprintf((char *)vfile_name.nameA_file,"alm%2.2ld.%3.3ld\0",year,day_year);
    return(TRANS_OK);
  }
  return(NO_FILE);
}}

// before call Init_almanac_strct() !!!!
short RdRtime::Read_ALMstrct()
{{
	short					 i,error=TRANS_OK;
  unsigned short prn_alm;
  almstrct    	 one_alm;

  error=IndentBuf_CheckingChecksum16();
	if (error!=TRANS_OK) return(error);

  memcpy(&one_alm,&bf.ibf[1],sizeof(one_alm));
  prn_alm=(unsigned short) bf.ibf[com.cnbyte-4];
  if ((prn_alm<0)||(prn_alm>31)) return(error);

	memcpy(&alm[prn_alm],&one_alm,sizeof(alm[prn_alm]));
  if (!rtf.f_wr_almGPS) rtf.f_wr_almGPS=1;

  swap_nbytes((char *)&one_alm.wn,sizeof(one_alm.wn));
  if ((one_alm.wn < 815)&&(one_alm.wn>=0)) one_alm.wn+=1024; // new epoch 22 august 1999 !!!
  swap_nbytes((char *)&one_alm.tow,sizeof(one_alm.tow));

  if (one_alm.wn>0)
  { rtt.alm_wn=one_alm.wn;
    rtt.alm_tow=one_alm.tow;
  }
  rtc.GPS_alm++;

  error=CurrAlmanacName();
  if (error==TRANS_OK)
	{	for (i=0; i<almanac_number; i++)
  		if (strstr((char *)vfile_name.nameA_file, (char *)malm[i].almanac_name)!=NULL) break;
		if (i<almanac_number)
   		malmanac_strctindex=i;
		else
		{ almanac_number++;
  		malmanac_strctindex=almanac_number-1;
			strcpy((char *)malm[malmanac_strctindex].almanac_name, (char *)vfile_name.nameA_file);
		}
		memcpy(&malm[malmanac_strctindex].alm[prn_alm],&alm[prn_alm],sizeof(alm[prn_alm]));
  }
  return(error);
}}

short RdRtime::GetPhotoData()
{{
	short error=TRANS_OK;

  error=IndentBuf_CheckingChecksum16();
	error=TRANS_OK;//if (error!=TRANS_OK) return(error);

  fwf.f_writePfile=1;
  len_strP=rdd.fill_byte-3; // -1 not used -2 checksum
  memcpy(str_photofile,&bf.ibf[1],len_strP);
  str_photofile[len_strP]='\0';

  return(error);
}}

short RdRtime::CompLengthEvent()
{{
  fa.string_length_event=bf.ibf[0]; // length in words
  if (fa.string_length_event<2) return(ERROR_FAT);
  rdd.fill_byte= (unsigned short)fa.string_length_event*2+2; // +2 checksum
  memcpy(str_Dfile,"C \0",3);
	len_strD=2;

  return(TRANS_OK);
}}

short RdRtime::GetEventData()
{{
	short i,error=TRANS_OK;
 	short	wn_event;
	char  str_WN_Dfile[MAX_LEN_DSTR];

	error=IndentBuf_CheckingChecksum16(); // com.cnbyte+1
	if (error!=TRANS_OK) return(error);

  if (bf.ibf[com.cnbyte-3]=='\n')
  	com.cnbyte-=3; // -1 indent -2 checksum
	else
		com.cnbyte-=4; // -1 indent -2 checksum -1 res(used)

	fwf.f_writeDfile=1;
	len_strD+=com.cnbyte;
	memcpy(&str_Dfile[2],&bf.ibf[1],com.cnbyte);
	str_Dfile[len_strD]='\0';
	for (i=0;i<len_strD;i++)
		if ((str_Dfile[i]=='\r')||(str_Dfile[i]=='\n'))
			break;
	if (i<len_strD)
	{ memcpy(bf.ibf,str_Dfile,i); bf.ibf[i]='\0';
		if (esnav.wn>815)
			wn_event=esnav.wn;
		else
		if (rh.wn_start>815)
			wn_event=(short) rh.wn_start;
		else
			wn_event=0;
		sprintf(str_WN_Dfile,"%s,%4d%s",bf.ibf,wn_event,&str_Dfile[i]);
		len_strD=0;
		if (f_open_Dfile==0)
		{	f_open_Dfile=1;
			len_strD=sprintf(str_Dfile,"%s\r\n","%VER=1\0");
			len_strD+=sprintf(&str_Dfile[len_strD],"%s%s,%s,%s,%s\r\n","%RID=\0",rh.rcvr_type,rh.nav_ver,rid_options,ser_num_rec);
		}
		len_strD+=sprintf(&str_Dfile[len_strD],"%s",str_WN_Dfile);
		if (str_WN_Dfile[strlen(str_WN_Dfile) - 1] != '\n')
		{
		  strcat(str_Dfile, "\r\n");
		  len_strD+=2;
		}
	}

	return(TRANS_OK);
}}

// ******************************************************************************
//  1128616537L,  // YREC
//  1380206658L,	// BHDR
//  151016002L,		// BR\X00\x09
//  369117271L,		// WH\X00\x16
//  1413763671L,	// WRDT
//  1128616517L,  // EREC
//  1128616513L,	// AREC
//  1128616525L,	// MREC
//  541282884L,		// DRC' '
// ******************************************************************************
short RdRtime::ReadBlocksUfile(const char* _pathVWfile)
{{
	unsigned short	len_data;

  if (!vmem.sum_blocks) return(NO_FILE);
	if (fVWfile==NULL)
	{ strcpy(pathVWfile, _pathVWfile);
		fVWfile=fopen(pathVWfile,"rb");
		if (fVWfile==NULL) return(NO_FILE);
		rtc.epoch = 0L;
		curr_bytes=0L;
	}
	if (vmem.sum_blocks-vmem.num_blocks==1)
		com.cnbyte=(unsigned short) (rawfile_length-vmem.num_blocks*512);
	fread(buf_block,com.cnbyte,1,fVWfile);
	len_data=com.cnbyte-time_tag;

	memmove(&buf_block[0],&buf_block[time_tag],len_data);
  memcpy(&bf.vibf[rtc.index_static_buf],buf_block,len_data);
  rtc.index_static_buf+=len_data;

  curr_bytes+=com.cnbyte;
	vmem.num_blocks++;
  rdd.percent=vmem.num_blocks*100.0/vmem.sum_blocks;
  if ((vmem.num_blocks%5==0)||(vmem.num_blocks==vmem.sum_blocks))
  { f_fillbuf=1;
		rtc.len_static_buf=rtc.index_static_buf;
    rtc.index_static_buf=0;
		if (vmem.num_blocks<=5)
	  { rdd.fill_byte=4;
			fa.data_type=NO_TYPE_HEADER;
  	}
  }
  return(COLLECTING_DATA);
}}

void RdRtime::Identification_data_type()
{{
  int  i;
  long fact_idf_header;

  memcpy(&fact_idf_header,bf.ibf,sizeof(fact_idf_header));
  for (i=0;i<9;i++)
  	if (fact_idf_header==idf_header_Ufile[i]) break;

  fa.data_type=i;
  switch(fa.data_type)
  { case YREC: 		// Y-body
      rdd.fill_byte=102;
   		break;
   	case BHDR: 		// BH-body
   		rdd.fill_byte=sizeof(rawheader)+2; // +2 checksum
   		break;
   	case BRX00X09:// V-body  -> ZTINYTYPE
   		fa.data_type=ZTINYTYPE;
    	rdd.cword=1;  // 2 byte
      break;
   	case WHX00X16:// WH-body -> TINYRANGER2
    	fa.data_type=TINYRANGER2;
    	rdd.cword=2;// 4 byte
			break;
   	case WRDT:    // W-body  -> TINYDRANGER2
			fa.data_type=TINYDRANGER2;
			rdd.cword=2;// 4 byte
      break;
   	case EREC:		// E-body
			rdd.fill_byte=sizeof(snavstrct);
   		break;
   	case AREC:    // ALM-body
			rdd.fill_byte=sizeof(almstrct)+4; // +2 (prnnum,res) +2 checksum
   		break;
   	case MREC:    // M-body
   	  rdd.fill_byte=28; // 26 M-string +2 checksum
   		break;
   	case DRC_:    // D-body
   	  rdd.fill_byte=1; // 1 length
   		break;
   	default:
   		// rdd.fill_byte is equal to 4 !!!
   		fa.data_type=NO_TYPE_HEADER;
			if (rtc.index_static_buf>=(rdd.fill_byte-1))
				rtc.index_static_buf-=(rdd.fill_byte-1);
			else
				rtc.index_static_buf=0;
	}
	if ((fa.data_type==ZTINYTYPE)||(fa.data_type==TINYRANGER2)||(fa.data_type==TINYDRANGER2))
	{		ControlRXCount();
			rdd.fill_byte=com.cnbyte;
	}
}}

short RdRtime::Read_data_fromRawfile()
{{
  short error = TRANS_OK;

  rdd.addr=0L; // not used !!!
  com.cnbyte=rdd.fill_byte;
  switch (fa.data_type)
  { case YREC: 		// Y-body 102 bytes
      error=GetYbody();
      if (error==TRANS_OK) FormSfile();
   		break;
   	case BHDR: 		// BH-body  sizeof(rawheader)+2 checksum
   		error=GetHeaderBfile();
   		break;
   	case ZTINYTYPE:
			if (rdd.cword==1)
			{	error=ZtinyComp_cword();
				if (error==TRANS_OK)
				{ ControlRXCount();
					memcpy(header_buf,bf.ibf,2);
					header_buf[2]='\0';
					rdd.fill_byte=com.cnbyte-2;
				}
			}
			else
			{	vfile_name.nameB_file[0]='B';
				memmove(&bf.ibf[2],bf.ibf,com.cnbyte);
				memcpy(bf.ibf,header_buf,2);
				com.cnbyte+=2;
				error=ReadZTINYTYPE();
			 	if (error==TRANS_OK)
			 	{ rdd.fill_byte=4;
			 	  fa.data_type=NO_TYPE_HEADER;
			 	}
			}
   		break;
   	case TINYRANGER2:
		case TINYDRANGER2:
			error=Rgr2Comp_cword();
			if (error==TRANS_OK)
			{ ControlRXCount();
      	rdd.fill_byte=com.cnbyte;
        if (fa.data_type==TINYRANGER2)
         	fa.data_type=TINYRANGER2C;
        else
        	fa.data_type=TINYDRANGER2C;
      }
   	  break;
   	case TINYRANGER2C:
		case TINYDRANGER2C:
			vfile_name.nameB_file[0]='C';
			if (fa.data_type==TINYRANGER2C)
				error=ReadTINYRANGER2();
			else
				error=ReadTINYDRANGER2();
			if (error==TRANS_OK)
			{ rdd.fill_byte=4;
			  fa.data_type=NO_TYPE_HEADER;
			}
   		break;
   	case EREC:		// E-body sizeof(snavstrct);
			error=ReadSNAV();
			break;
   	case AREC:    // ALM-body sizeof(almstrct)+2 checksum
			error=Read_ALMstrct();
   		break;
   	case MREC:    // M-body Photo-data
			error=GetPhotoData();
   		break;
   	case DRC_:    // D-body
   	  if (rdd.fill_byte==1)
   			error=CompLengthEvent(); // computed rdd.fill_byte.
   		else
   		{ error=GetEventData();
				if (error==TRANS_OK)
			 	{ rdd.fill_byte=4;
			 	  fa.data_type=NO_TYPE_HEADER;
			 	}
   		}
   		break;
  }
  if (error!=TRANS_OK) // LOG FILE !!!
  {	short v_type;
  	short nTag,curr_num_blocks;
  	FILE  *fL=NULL;
  	char  *s_type;
		short length_path;
		char  _pathErrorfile[200];

		static char *str_types[10]=
  	{ "YREC\0",			"BHDR\0",	"BRX00X09\0",
  		"WHX00X16\0", "WRDT\0", "EREC\0",
  		"AREC\0",		  "MREC\0", "DRC_\0",  "UNKNOWN\0"
  	};

  	v_type=fa.data_type;
 	  if (v_type==ZTINYTYPE) v_type=BRX00X09;
 	  if ((v_type==TINYRANGER2)||(v_type==TINYRANGER2C)) v_type=WHX00X16;
  	if ((v_type==TINYDRANGER2)||(v_type==TINYDRANGER2C)) v_type=WRDT;
  	s_type=(v_type>=0 && v_type < 9 ) ? str_types[v_type] : str_types[9];

  	if (pathDataFile[0]!='\0')
		{	strcpy(_pathErrorfile,pathDataFile);
			length_path=strlen(_pathErrorfile);
#ifdef __GNUC__
			if (_pathErrorfile[length_path-1]!='/') strcpy(&_pathErrorfile[length_path],"/\0");
#else
			if (_pathErrorfile[length_path-1]!='\\')strcpy(&_pathErrorfile[length_path],"\\\0");
#endif
			strcat(_pathErrorfile,"error.log\0");
		}
		else
			strcpy(_pathErrorfile,"error.log\0");
		rtc.error_epoch++;
		fL=fopen(_pathErrorfile,"a+");
  	fprintf(fL,"\n\n Name:                    %s",&pathVWfile[1]);
  	fprintf(fL,"\n Data type:               %s",s_type);
		curr_num_blocks=rtc.len_static_buf/508;
		nTag=(rtc.index_static_buf/508)*4;
		if (rtc.index_static_buf%508) nTag+=4;
  	fprintf(fL,"\n Index in raw data:       %lu",(long)(vmem.num_blocks-curr_num_blocks)*512+rtc.index_static_buf+nTag);
  	fprintf(fL,"\n Number of an error:      %lu", rtc.error_epoch);
		fclose(fL); fL=NULL;
  }
  if ((error!=TRANS_OK)||
	   	((fa.data_type>=YREC)&&(fa.data_type<DRC_))
	   )
	{ rdd.fill_byte=4;
		fa.data_type=NO_TYPE_HEADER;
	}
  return(error);
}}
