///////////////////////////////////////////////////////////////////////////////	
//    Ashtech receiver tools
//    Copyright (C) 1999  Magellan Coropration/Ashtech Precision Products 
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
///////////////////////////////////////////////////////////////////////////////


#include <string.h>

#ifndef __TRANS_HPP
#include "trans.hpp"
#endif

short Trans::AnalysReadfRec()
{{
  short error = TRANS_OK; 
	
  switch (fa.type_analyse  )
  { case ANSHEAD:
			rdd.percent=0.0;
			if (f_ring_buffer)
			{	com.cnbyte=sizeof(ring_header_strct); 
				fread(&bf.ibf,com.cnbyte,1,fImage);
				error=GetRingHead();
				if (error!=TRANS_OK) return(error);
				// nextly 32-SNAV structures
				fa.type_analyse=DATA;
				fa.var_analyse=0;
				fa.data_type=SNAV;
				rdd.cword=132/2;
			}
			else
			{	com.cnbyte=sizeof(header_strct);		
				fread(&bf.ibf,com.cnbyte,1,fImage);
				error=GetHeadFile();      // head <-
				if (error!=TRANS_OK) return(error);
				rdd.addr=sizeof(image_head)+file_header.segbeg*2L; // in bytes !!! 
				fseek(fImage,rdd.addr,SEEK_SET);
				fa.var_analyse=-1;          // type ->
			}
			memcpy(&all_file_rec,&file_rec,sizeof(file_dir));
			rdd.number_error=0L;
			rdd.addr=file_header.segbeg;
			f_fillbuf=0; 
			rdd.fill_buf_block=0;
			rdd.fill_byte=0;
			break;
    case ANSTYPE:
      fa.data_type=GetTypeData(); // type <-
      error=Change_num_obs_types();
      rdd.addr +=1L;
      fa.type_analyse  =DATA;
			fa.var_analyse=0;
			if ((error!=TRANS_OK)||(fa.data_type<0))
			{ error=COLLECTING_DATA;
				fa.type_analyse=ANSTYPE;
				fa.var_analyse=-1; 
				break;
			}
		case DATA:                    // data -><-
    switch (fa.data_type)
    { case SNAV: // for E-file
				if ((fa.curr_file_type!=GEODETIC)&&
						(fa.curr_file_type!=RANGER_MODE1)&&
						(fa.curr_file_type!=RANGER_MODE3))
				{	fa.type_analyse=ANSTYPE; // new find
					fa.var_analyse=-1; 
					break;
				}
				rdd.cword=132/2;          // snav ->
				if (fa.var_analyse==1)
				{	error=ReadSNAV();			  // snav <-
					if (f_ring_buffer)
					{	rdd.snav_number++;
						fa.var_analyse=0;
						rdd.addr +=(unsigned long) rdd.cword; // any SNAV !!! ->
						if (rdd.snav_number==32L)
						{	fa.data_type=TINYRANGER3;
							rdd.mode_offset_addr=0;
							GetRingAddrOffset(rdd.mode_offset_addr);
							if (ring_head.record_size!=0)
								rdd.cword=ring_head.record_size;
							else
								rdd.cword=1;
						}			
					}
					else
						fa.var_analyse=-1;      // type ->
				}
				break;
      case ATT_3DF: // (3DF receiver only) for S-file
				rdd.cword=48/2;           // att ->
				if (fa.var_analyse==1)
				{ error=ReadATT_3DF();    // att <-
					fa.var_analyse=-1;      // type->
				}
				break;
      case EVENT: // bar-code
				if (fa.var_analyse==0) rdd.cword=1; // head_event ->
				if (fa.var_analyse==1)
				{ if (rdd.cword==1)
					{ fseek(fImage,-com.cnbyte,SEEK_CUR);
						error=ReadHeadEVENT();// head_event <-
						if (error!=TRANS_OK) 
						{	fa.var_analyse=-1; 
						  fa.type_analyse=ANSTYPE;
						}
						else 
							fa.var_analyse=0;  	// event ->
						break;
					}
					if (rdd.cword>1)
					{ error=ReadEVENT();    // event <-
						fa.var_analyse=-1;    // type  ->
					}
				}
				break;
      case MBEN: // [ M-XII, D-XII ] channel measurement data for B-file
				if (fa.var_analyse==0)
				{ if ((fa.curr_file_type !=GEODETIC)&&(fa.curr_file_type !=RANGER_MODE3)) 
					{	fa.type_analyse=ANSTYPE; // new find
						fa.var_analyse=-1; 
						break;
					}
				  rdd.cword=sizeof(mbenstrct)/2+1; // +1 checksum
				  rdd.block_no=0;         // mben ->
				}
				if (fa.var_analyse==1)
				{ error=ReadMBEN();       // mben <-
				  if (error==NO_FILLMBEN) 
						fa.var_analyse=0;			// mben -> noch
					else 
						fa.var_analyse=-1;		// find type ->
				}
				break;
      case PBEN: // [ M-XII, D-XII ] nav data for B-file
				if ((fa.curr_file_type !=GEODETIC)&&(fa.curr_file_type !=RANGER_MODE3)) 
				{	fa.type_analyse=ANSTYPE; // new find
					fa.var_analyse=-1; 
					break;
				}
				rdd.cword=sizeof(pbenstrct)/2+1; // +1 checksum // pben ->
				if (fa.var_analyse==1)
				{ error=ReadPBEN();                             // pben <-
					fa.var_analyse=-1;      // type ->
				}
				break;
      case RNAV: // [ DMA ] for N-file
				if ((fa.curr_file_type !=GEODETIC)&&
				    (fa.curr_file_type!=RANGER_MODE1)&&
						(fa.curr_file_type!=RANGER_MODE3))
				{	fa.type_analyse=ANSTYPE; // new find
					fa.var_analyse=-1; 
					break;
				}
				rdd.cword=sizeof(rnavstrct)/2+1; // +1 checksum // rnav ->
				if (fa.var_analyse==1)
				{ error=ReadRNAV();                             // rnav <-
					fa.var_analyse=-1;      // type ->
				}
				break;
      case RALM: // [ DMA ] for A-file
				if (fa.var_analyse==0)
				{ if ((fa.curr_file_type !=GEODETIC)&&
						  (fa.curr_file_type!=RANGER_MODE1)&&
							(fa.curr_file_type!=RANGER_MODE3)
							)
					{	fa.type_analyse=ANSTYPE; // new find
						fa.var_analyse=-1; 
						break;
					}
				  rdd.cword=1;              // num_pages ->
				}
				if (fa.var_analyse==1)
				{ if (rdd.cword==1)
				  { fseek(fImage,-com.cnbyte,SEEK_CUR);
						error=ReadRALMnpages(); // num_pages <-
				    if (error!=TRANS_OK)
						{	fa.var_analyse=-1; 
						  fa.type_analyse=ANSTYPE;
						}
						else
							fa.var_analyse=0;	// ralm ->
				    break;
				  }
				  if (rdd.cword>1)
				  { error=ReadRALM();     // ralm <-
				    fa.var_analyse=-1;    // find type ->
				  }
				}
				break;
      case PTINYTYPE: // [ >= 6F ]  for B-file
				if (fa.var_analyse==0)
				{ if (fa.curr_file_type !=GEODETIC) 
					{	fa.type_analyse=ANSTYPE; // new find
						fa.var_analyse=-1; 
						break;
					}
				  rdd.cword=1;               // mbens ->
				}
				if (fa.var_analyse==1)
				{ if (rdd.cword==1)
				  { fseek(fImage,-com.cnbyte,SEEK_CUR);
						PtinyComp_cword();    // mbens <-
				    fa.var_analyse=0;     // ptiny ->
				    break;
				  }
				  if (rdd.cword>1)
				  { error=ReadPTINYTYPE();// ptiny <-
				    fa.var_analyse=-1;    // type ->
				  }
				}
				break;
      case ZTINYTYPE: //[ Z- ] ---------- " ----------
				if (fa.var_analyse==0)
				{ if (fa.curr_file_type !=GEODETIC) 
					{	fa.type_analyse=ANSTYPE; // new find
						fa.var_analyse=-1; 
						break;
					}
				  rdd.cword=1;               // mbens ->
				}
				if (fa.var_analyse==1)
				{ if (rdd.cword==1)
				  { fseek(fImage,-com.cnbyte,SEEK_CUR);
						error=ZtinyComp_cword(); // mbens <-
						if (error!=TRANS_OK) 
						{	fa.var_analyse=-1; 
						  fa.type_analyse=ANSTYPE;
						}
					  else 
							fa.var_analyse=0; // ztiny ->
				    break;
				  }
				  if (rdd.cword>1)
				  { error=ReadZTINYTYPE();// ztiny <-
				    fa.var_analyse=-1;    // type ->
				  }
				}
				break;
      case TINYCODELESS: // CLTINYTYPE [ >=6F ]  ---------- " ----------
      case TINYTYPE:     // [ 5E-6E ] or [ <5E ] --------- " ----------
      case TINYTINYTYPE: 
				if (fa.var_analyse==0)
				{ if (fa.curr_file_type !=GEODETIC) 
					{	fa.type_analyse=ANSTYPE; // new find
						fa.var_analyse=-1; 
						break;
					}
					rdd.cword=1;            // mbens ->
				}
				if (fa.rcvr_version==A_5)
				{ if (fa.var_analyse==1)
				  { if (rdd.cword==1)
				    { fseek(fImage,-com.cnbyte,SEEK_CUR);
							A5benComp_cword();  // mbens <-
				      fa.var_analyse=0;   // a5ben ->
				      break;
				    }
				    if (rdd.cword>1)
				    { error=ReadA5BENstruct(); // a5ben <-
				      fa.var_analyse=-1;  // type ->
				    }
				  }
				  break;
				}
				else
				  if (fa.data_type==TINYCODELESS)
				  { if (fa.var_analyse==1)
				    { if (rdd.cword==1)
				      { fseek(fImage,-com.cnbyte,SEEK_CUR);
								TinycodComp_cword();      // mbens <-
								fa.var_analyse=0;         // tinycod ->
								break;
				      }
				      if (rdd.cword>1)
				      { error=ReadTINYCODELESS(); // tinycod <-
								fa.var_analyse=-1;				// find type ->
				      }
				    }
				    break;
				  }
				  else
				  { if (fa.var_analyse==1)
				    { if (rdd.cword==1)
				      { fseek(fImage,-com.cnbyte,SEEK_CUR);
								BenComp_cword();       // mbens <-
								fa.var_analyse=0;      // ben ->
								break;
				      }
				      if (rdd.cword>1)
				      { error=ReadBENstruct(); // ben <-
								fa.var_analyse=-1;		 // find type ->
				      }
				    }
				    break;
				  }
      case TINYRANGER1:  // [ >=6F ] or [ < 6F ] ---------- " ----------
				if (fa.var_analyse==0)
				{ if (fa.curr_file_type!=RANGER_MODE1) 
					{	fa.type_analyse=ANSTYPE; // new find
						fa.var_analyse=-1; 
						break;
					}
				  rdd.cword=1;              // block_len ->
				}
				if (fa.var_analyse==1)
				{ if (rdd.cword==1)
				  { error=Rgr1Comp_cword(); // block_len <-
				    if (error!=TRANS_OK) 
						{	fa.var_analyse=-1; 
						  fa.type_analyse=ANSTYPE;
						}
						else						
							fa.var_analyse=0; // tiny_ran1 ->
				    break;
				  }
				  if (rdd.cword>1)
				  { error=ReadTINYRANGER1();// tiny_ran1 <-
				    fa.var_analyse=-1;      // type ->
				  }
				}
				break;
      case TINYRANGER2:  //  ---------- " ----------
				if (fa.var_analyse==0)
				{ if (fa.curr_file_type!=RANGER_MODE2) 
					{	fa.type_analyse=ANSTYPE; // new find
						fa.var_analyse=-1; 
						break;
					}
				  rdd.cword=2;              // block_len ->
				}
				if (fa.var_analyse==1)
				{ if (rdd.cword==2)
				  { error=Rgr2Comp_cword(); // block_len <-
				    if (error!=TRANS_OK) 
						{	fa.var_analyse=-1; 
						  fa.type_analyse=ANSTYPE;
						}
						else						
							fa.var_analyse=0; // tiny_ran2 ->
				    break;
				  }
				  if (rdd.cword>2)
				  { error=ReadTINYRANGER2();// tiny_ran2 <-
						fa.var_analyse=-1;      // type ->
					}
				}
				break;
      case TINYRANGER3:  //  ---------- " ----------
				if (fa.var_analyse==0)
				{ if (fa.curr_file_type!=RANGER_MODE3) 
					{	fa.type_analyse=ANSTYPE; // new find
						fa.var_analyse=-1; 
						break;
					}
				  rdd.cword=1;               // mbens ->
				}
				if (fa.var_analyse==1)
				{ if (rdd.cword==1)
				  { fseek(fImage,-com.cnbyte,SEEK_CUR);
						error=Rgr3Comp_cword(); // mbens <-
						if (error!=TRANS_OK) 
						{	fa.var_analyse=-1; 
						  fa.type_analyse=ANSTYPE;
						}
					  else 
							fa.var_analyse=0; // tiny_ran3 ->
				    break;
				  }
				  if (rdd.cword>1)
				  { error=ReadTINYRANGER3();// tiny_ran3 <-
				    if (f_ring_buffer)
						{	rdd.curr_ben_number++;
							rdd.addr +=(unsigned long) rdd.cword;
							fa.var_analyse=0;
							if (ring_head.record_size!=0)
								rdd.cword=ring_head.record_size;
							else
								rdd.cword=1;
							if (rdd.curr_ben_number==rdd.ben_number)
							{	if ((ring_head.num_records>rdd.ben_number)&&(rdd.mode_offset_addr==0)) 
								{ rdd.mode_offset_addr=1;
									GetRingAddrOffset(rdd.mode_offset_addr);
								}	
								else
									fa.var_analyse=-1;    
							}
						}
						else
							fa.var_analyse=-1;    // type ->
				  }
				}
				break;
		default: 
				fa.var_analyse=-1; // new find data_type
				fa.type_analyse=ANSTYPE;
				error=COLLECTING_DATA;
    }
  }
  if ((fa.var_analyse==0)&&(fa.type_analyse==DATA))
  { SendRdfromRec(); // -----> DATA
		rdd.percent=(rdd.addr-file_header.segbeg)*100.0/file_header.wordcount;
    fa.var_analyse=1;      // <----- DATA
  }
  if ((fa.var_analyse<0)&&(fa.type_analyse==DATA))
  { if (f_ring_buffer)
			rdd.addr=file_header.segbeg+file_header.wordcount;
		else
			rdd.addr +=(unsigned long) rdd.cword;  // rdd.addr fa.data_type
    rdd.percent +=rdd.cword*100.0/file_header.wordcount;
  }
  if ((((long)rdd.addr-file_header.segbeg)>=file_header.wordcount)&&(fa.type_analyse>ANSHEAD))
  { rdd.percent=100.0;
    return(TRANS_OK);
  }
  if (fa.var_analyse<0) 
  { rdd.cword=1;       // fa.data_type ---->
    SendRdfromRec();
    rdd.percent=(rdd.addr-file_header.segbeg)*100.0/file_header.wordcount;
		fa.type_analyse=ANSTYPE;
	}
  if ((error!=TRANS_OK)&&(error!=COLLECTING_DATA))
	{ 
	  FILE  *fL=NULL;
  	short length_path;
		char  _pathErrorfile[200];

  	if (pathDataFile[0]!='\0')
		{	strcpy(_pathErrorfile,pathDataFile);
			length_path=strlen(_pathErrorfile);
#ifdef __GNUC__				
			if (_pathErrorfile[length_path-1]!='/') strcpy(&_pathErrorfile[length_path],"/\0");
#else
			if (_pathErrorfile[length_path-1]!='\\')strcpy(&_pathErrorfile[length_path],"\\\0");			
#endif			
			strcat(_pathErrorfile,"error.log\0");
		}
		else
			strcpy(_pathErrorfile,"error.log\0");
		rdd.number_error++;
		fL=fopen(_pathErrorfile,"a+");
  	fprintf(fL,"\n\n Name:                    %s",pathImagefile);
  	fprintf(fL,"\n Data type:               %d",fa.data_type);

  	fprintf(fL,"\n Index in raw data:       %lu",(long)(rdd.addr*2L+sizeof(image_head)));
  	fprintf(fL,"\n Number of an error:      %lu", rdd.number_error);
		fclose(fL); fL=NULL;
  }

	error=COLLECTING_DATA;
	return(error); // error!=TRANS_OK -> eWarningBadCheckSum
}}

