#!/usr/bin/perl
#    Ashtech remote receiver access tools
#    Copyright (C) 1999  Magellan Coropration/Ashtech Precision Products 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#     FILE:        em1000.pl
#
#     DESCRIPTION: This PERL script connects to the em1000 
#                  Ethernet modem via TCP, and then duplicate
#                  the socket file descriptr to <STDIN> <STDOUT>.
#                  That allows the rest of scripts work with the 
#                  receiver without knowledge of physical nature 
#                  of connection.
#
#     $Id: em1000.pl,v 1.1 1999/12/10 05:12:58 serg Exp $
#
#
#############################################################################
require 5.002;
#use strict;
use Socket;

sub TcpConnect{
my ($remote,$port) = @_;
my ($iaddr, $paddr, $proto, $line);

$port  = 8888 if not defined $port;  # default port
die "No port" unless $port;

print STDERR "Connect to [$remote]:[$port]\n";

# Connect to $remote:$port

$iaddr   = inet_aton($remote)               || die "no host: $remote";
$paddr   = sockaddr_in($port, $iaddr);
$proto   = getprotobyname('tcp');
socket(SOCK, PF_INET, SOCK_STREAM, $proto)  || die "socket: $!";
connect(SOCK, $paddr)    || die "connect: $!";

# Redirect the socket to the standard input/output 

open(STDIN,  "<&SOCK")   || die "can't dup  to stdin";
open(STDOUT, ">&SOCK")   || die "can't dup  to stdout";

sleep 1;
$| = 1;
sleep 1;
select(STDOUT); $| = 1;     # make unbuffered
sleep 1;
return 1;
}

1;



