#!/usr/bin/perl
#    Ashtech remote receiver access tools
#    Copyright (C) 1999  Magellan Coropration/Ashtech Precision Products 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#----------------------------------------------------------------------------
#
#     FILE:        rawdld.pl
#
#     DESCRIPTION: This PERL script 
#
#     $Id: rawdld.pl,v 1.1 1999/12/03 03:55:56 serg Exp $
#
#
#############################################################################

############################################################################
#
# Subroutine: ConnectToReceiver
#
# Description: Runs the script to configure the receiver modem
#
# Parameters:  None
#
############################################################################
sub GetRawDataDir
{
    my( $ScriptDir,$Port,$LogIdFile,$RawLogDirectory );

    # Build ID file name using the script directory and port names

    $ScriptDir = ReadVar($ConfigFile,"ScriptDir",".");
    $Port      = ReadVar($ConfigFile,"Port");
    $Port      =~ tr/\//\./; # Replace / with . 

    $LogIdFile  = $ScriptDir . "/" . $Port;

    if ( open(LOG_ID,"$LogIdFile") )
    {
	$RawLogDirectory =  <LOG_ID>;
	chop($RawLogDirectory);

	close(LOG_ID);
	print STDERR "Log directory: [$RawLogDirectory]\n";
	undef  $RawLogDirectory if not -d $RawLogDirectory ;
    }
    else
    {
	PrintStatus ("Can't open ID file $LogIdFile");
    }
    return $RawLogDirectory;
}

############################################################################
#
# Subroutine: GetFileListLogger
#
# Description: 
#
# Parameters:  None
#
############################################################################
sub GetFileListLogger
{
    my ($DirName) = @_;
    my ( @Dir );

# Read the directory contens    
    opendir(RAW_LOG_DIR,$DirName) or die "Can not open directory $DirName";
    @Dir = readdir(RAW_LOG_DIR);
    closedir(RAW_LOG_DIR);

# Find valid files in the directory

    $FilesFound = 0;

    @Dir = sort ( @Dir );
    
    foreach  $DirEntry (@Dir)
    {
	if ((not -d $DirEntry)  ) # File is not directory
	{                                           # and is readable
	    # Name should be like   L____A00.123
	    if (  $DirEntry=~     /^L.......\.\d\d\d$/ ) 
	    {
		print STDERR "File $DirEntry\n";
		$FileName[$FilesFound] = $DirName . "/" . $DirEntry;
		@FileInfo = stat( $FileName[$FilesFound] );
		$FileDate[$FilesFound] = $FileInfo[10];
		$FileSize[$FilesFound] = $FileInfo[7];
		$FileOpen[$FilesFound] = 0 ;
		$FileDeleted[$FilesFound] = 0;
		$FilesFound ++;
	    }
	}
    }
    return $FilesFound;
}

1;






















